import StringLinerizer;
import MovingObj;
import java.awt.*;
import java.applet.*;
import java.net.URL;

class THUser
{
	private int ID;
	private Name name;
	private Point pos;
	private Room room;
	private Dymek dym;
	private Glowa glowa;
        public int oldx, oldy;

 	public THUser(Room r, int id, String nm, Point p) {
		room = r;
		ID = id;
		pos = p;
		dym = new Dymek(this, pos.x, pos.y);
		glowa = new Glowa(this, pos.x, pos.y);
		Rectangle rr = glowa.getZone();
		name = new Name(this, nm, rr.x+rr.width/2, rr.y+rr.height+5); 
 	}

	public void changeFace( String sURL) {
	 	glowa.changeLook( sURL); 
	}

	public String getName() { return name.toString(); }

	synchronized public void move(Graphics g, int dx, int dy){
	 	glowa.move(g,dx,dy);
	}

	synchronized public void moveEnd() {
	 	Rectangle pos = glowa.getZone();
		dym.moveEnd( pos.x, pos.y);
		name.moveEnd( pos.x+pos.width/2, pos.y+pos.height+5);
	}

	public int getID() { return ID; }

	synchronized public void paint (Graphics g) {
		paintGlowa(g);
		paintDymek(g);
		paintName(g);
	}

	synchronized public void setInMove( boolean m) { 
		glowa.setInMove( m); 
		dym.setInMove( m);
		name.setInMove( m);	
	}

	synchronized public void paintGlowa(Graphics g) { glowa.paint(g); }
	synchronized public void paintDymek(Graphics g) { dym.paint(g); }
	synchronized public void paintName(Graphics g) { name.paint(g); }

	synchronized public void paintArea( Graphics g, Rectangle rect) {
	 	if (glowa.inform( rect)) paintGlowa(g);
	 	if (dym.inform( rect)) paintDymek(g);
	 	if (name.inform( rect)) paintName(g);
	}
	
	synchronized public void clear( Graphics g) {
	 	if (!glowa.isActive()) clearGlowa(g);
		if (!dym.isActive()) clearDymek(g);
		if (!name.isActive()) clearName(g);
	}

	synchronized public void clearGlowa(Graphics g) { glowa.clear(g); }
	synchronized public void clearDymek(Graphics g) { dym.clear(g); }
	synchronized public void clearName(Graphics g) { name.clear(g); }

	public Point getPosition() { return pos; }
	public Rectangle getGlowaArea() { return glowa.getZone(); }
			
	public void say(String txt) {
		dym.setTxt(txt);
	}

	public Room getRoom() {
		return room;
	}

	public boolean mouseWithin(int x,int y) {
		Rectangle rect = glowa.getZone();
		if ((x>rect.x)&&(x<rect.x+rect.width)
			  &&(y<rect.y+rect.height)&&(y>rect.y))
			return true;
		else
			return false;
	}	

	synchronized public void move(int x, int y) {
		pos.x += x;
		pos.y += y;
	}
	
}

class Glowa extends MovingObj
{
	private THUser user;
	private Image image = null;
	private Loader loader = null;
	
	public Glowa(THUser u, int x, int y){
		super(x,y,80,80,true);
		user = u;
		image = user.getRoom().getApplet().createImage( 80, 80);
		standardFace( image);		 
	}

	public void standardFace( Image img) {
		Graphics g = img.getGraphics();
		g.setColor( Color.lightGray);
		g.fillRect( 0,0,80,80);
		g.setColor( Color.green);
		g.fillOval( 0,0,79,79);
		g.setColor( Color.black);
		g.fillOval( 25,20,4,4);
		g.fillOval( 55,20,4,4);
		g.drawArc( 20,20,40,40,240,60);
	}
	
	synchronized public void paint(Graphics g) {	
       	g.drawImage(image,zone.x,zone.y,zone.width,zone.height,Color.lightGray,null); 
	}

	synchronized public void paintArea( Graphics g, int x, int y, int w, int h) {
		user.getRoom().paintUsers( g, x, y, w, h);
	}
	
	synchronized public void changeLook( String sURL) {
		if (loader != null)
			loader.stop();
	 	loader = new Loader( sURL, user.getRoom().getApplet(), this);
		loader.start();
	}

	synchronized public void setImage( Image img) {
		image = img;
		loader = null;
		if (!inMove) {
            user.getRoom().userOnTop( user);
			Graphics g = user.getRoom().getGraphics();
//            user.paint(g);
	    paint(g);	
		}
	}	

}


class Dymek extends MovingObj
{
	private String txt;
	private THUser user;
	final private int blank = 8;	
	final private int LineWidth = 20; 
		
	public Dymek(THUser u, int x, int y) {
		super(x,y-8,0,0,false);
		user = u;
		setTxt( "Hello ...");
	}
	
	private Dimension getRectDim(FontMetrics font, String str) {
		Dimension dd = new Dimension();
		int lineWidth = 0;
		StringLinerizer lines = new StringLinerizer(str,LineWidth);
		dd.height = lines.countLines() * font.getHeight() + blank;
		while(lines.hasMoreLines()) {
			int width = font.stringWidth(lines.nextLine());
			if(width > lineWidth) lineWidth = width;
		}
		dd.width = lineWidth + 2*blank;
		return dd;
	}
			
	private int justify(String s, FontMetrics f, int line) {
		int width = f.stringWidth(s);
		return (line - width)/2;
	}	
	
	synchronized public void paint(Graphics g) {
		FontMetrics font = g.getFontMetrics();
		g.setColor(Color.white);
		g.fillRoundRect(zone.x, zone.y, zone.width, zone.height, 6,6);
		g.setColor(Color.black);
		g.drawRoundRect(zone.x, zone.y, zone.width, zone.height, 6,6);

		int h = font.getHeight();
		int y = zone.y;

		StringLinerizer lines = new StringLinerizer(txt,LineWidth);
		while(lines.hasMoreLines()) {
			String tmp = lines.nextLine();
			int intend = justify(tmp,font,zone.width);
			y += h;
			g.drawString(tmp,zone.x+intend,y);
		}
	}
			
	synchronized public void paintArea( Graphics g, int x, int y, int w, int h) {
		user.getRoom().paintUsers( g, x, y, w, h);
	}

	synchronized public void setTxt(String t) { 	
		txt = t; 
		Graphics g = user.getRoom().getGraphics();
		if (!inMove) clear(g);
		FontMetrics font = g.getFontMetrics();
		Dimension recDim = getRectDim(font,txt);
		zone.reshape(zone.x,zone.y+zone.height - recDim.height,recDim.width, recDim.height);
		if (!inMove) paint(g);
	}

	synchronized public void moveEnd( int x, int y) {
	 	zone.x = x;
		zone.y = y - zone.height - blank;
	}
}


class Name extends MovingObj {
 	private String name;
	private THUser user;
	
	public Name(THUser u, String n, int x, int y){
		super(x,y,0,0,false);
		user = u;
		setName(n);
	}

	public String toString() { return name; }

	public void setName(String n) {
		name = n;
		Graphics g = user.getRoom().getGraphics();
		FontMetrics font = g.getFontMetrics();
		int xx = zone.x + zone.width/2;
		zone.height = font.getHeight();
		zone.width = font.stringWidth(name)+8;
		zone.x = xx-zone.width/2;
	}
	
	synchronized public void paint(Graphics g) {
		g.setColor( Color.lightGray);
		g.fillRect( zone.x, zone.y, zone.width, zone.height);
		g.setColor( Color.black);
		g.drawString(name, zone.x + 4, zone.y + zone.height-4);
	}

	synchronized public void paintArea( Graphics g, int x, int y, int w, int h) {
		user.getRoom().paintUsers( g, x, y, w, h);
	}

	synchronized public void moveEnd( int x, int y) {
	 	zone.x = x;
		zone.y = y;
		zone.width = zone.height = 0;
		setName( name);
	}

}

class Loader extends Thread
{
	private String sURL;
	private Applet applet;
	private Image image;
	private static int id;
	private Glowa parent;

	public Loader( String surl, Applet ap, Glowa p) {
		sURL = surl;
		applet = ap;
		id = 0;
		parent = p;
		setPriority(MIN_PRIORITY);
	} 

 	public void run() {
		try {
			image = applet.getImage( applet.getCodeBase(), sURL);
            MediaTracker mt = new MediaTracker( applet);
			mt.addImage( image, ++id);
			mt.waitForID( id);
		}
		catch( Exception e) {
			System.err.println( "Loader exception: " + e);
		}
		parent.setImage( image);
	}

}

